var filaSeleccionadaRelOriDir;

jQuery(function($){
	
	$("#menuTablasBasicas").addClass("active");
	
	var inspeccionCargada = sessionStorage.getItem("inspeccionCargada");
	
	if (inspeccionCargada !== null)
	{
		$("#menuFichaInspeccion").removeClass("disabled");
		/* Para completar la url del menú Ficha Inspección */
		 var link=$("#menuFichaInspeccion a").attr("href");
		 $("#menuFichaInspeccion a").attr("href",link+inspeccionCargada);
		 
		/* Para completar la url del menú Listados */
		 var link=$("#menuListados a").attr("href");
		 $("#menuListados a").attr("href",link+inspeccionCargada);
	}
	
	
	//Feedback tabla
	$("#relOriDireccionFeedback").rup_feedback({
		gotoTop : true,
		block : false,
		delay : 8000,
		fadeSpeed : 500
	});
	
	$("#relOriDir_detail_feedback").rup_feedback({
		gotoTop : true,
		block : false,
		delay : 8000,
		fadeSpeed : 500
	});
	
	bloquearInterfaz();
	
	//Tabla preguntas validación
	$("#relOriDireccion").rup_datatable({
		
		primaryKey: "idRelOriDir",
		loadOnStartUp: true,
		pagingType: "full_numbers",
		dom: 'rt<"bottom"lip>',
		pageLength : 5,
		lengthMenu: [5, 10, 25, 50],
		colReorder: false,
		filter:{
  	  		id:"relOriDir_filter_form",
  	  		filterToolbar:"relOriDir_filter_toolbar",
  	  		collapsableLayerId:"relOriDir_filter_fieldset"
     	},
     	columnDefs: [
     		{
     			targets: [1,2,4],
     			visible: false
     		},
     		{
     			targets: [0,1,2,3,4,5],
     			orderable: false
     		},
     		{
		    	targets: [5],
		    	render: function(data){
		    		if(data === 1){
		    			if ("eu" === $.rup_utils.get("language")){
		    				return 'Bai'
		    			} else {
		    				return 'Sí';
		    			}
		    		} else if(data === 2){
		    			if ("eu" === $.rup_utils.get("language")){
		    				return 'Ez'
		    			} else {
		    				return 'No';
		    			}
		    		}
		    	},
     			className: "text-center"
		    }
     	],
     	drawCallback: function () {
     		filaSeleccionadaRelOriDir = "";
     	},
		initComplete: function(){
			
			var tablaRelOriDir = $("#relOriDireccion").DataTable();
			
			//Mostrar / ocultar campos dependiendo del idioma
			if ("eu" === $.rup_utils.get("language")){
				tablaRelOriDir.columns( [0,3] ).visible( false );
				tablaRelOriDir.columns( [2,4] ).visible( true );
			} else if("es" === $.rup_utils.get("language")) {
				tablaRelOriDir.columns( [2,4] ).visible( false );
			}
			
			var spanM = document.createElement("span"); 
			var mostrando = document.createTextNode($.rup.i18n.app.paginador.mostrando); 
			spanM.appendChild(mostrando);
			spanM.className = "mostrando";
			var spanR = document.createElement("span"); 
			var registros = document.createTextNode($.rup.i18n.app.paginador.registros); 
			spanR.appendChild(registros);
			spanR.className = "registros";
			
			var longitudTabla = document.getElementById("relOriDireccion_length"); 
			longitudTabla.appendChild(spanM); 
			longitudTabla.appendChild(spanR);
			
			desbloquearInterfaz();
			
		}
	});
	
	var tablaRelOriDir = $("#relOriDireccion").DataTable();
	
	//Fila seleccionada
	$('#relOriDireccion tbody').on( 'click', 'tr', function () {
		filaSeleccionadaRelOriDir = tablaRelOriDir.row(this).data();
		if ( $(this).hasClass('selected') ) {
	        $(this).removeClass('selected');
	    }
	    else {
	    	tablaRelOriDir.$('tr.selected').removeClass('selected');
	        $(this).addClass('selected');
	    }
		
		if(filaSeleccionadaRelOriDir.numeroRespuestas > 0){
			$("#btnEditarRelOriDir").prop("disabled", true);
		} else{
			$("#btnEditarRelOriDir").prop("disabled", false);
		}
		
	});
	
	$('#relOriDireccion tbody').on('dblclick', 'tr', function () {
		$("#btnEditarRelOriDir").trigger("click");
	});
	
	//Editar pregunta
	$("#btnEditarRelOriDir").click(function(){
		
		if(typeof filaSeleccionadaRelOriDir !== "undefined" && filaSeleccionadaRelOriDir !== null && filaSeleccionadaRelOriDir !== ""){
			bloquearInterfaz();
			recuperarRegistro();
		} else{
			$("#relOriDireccionFeedback").rup_feedback("set", $.rup.i18n.app.feedback.error.lineaNoSeleccionada, "alert")
		}		
		
	});
	
	//Modal mantenimiento
	$("#relOriDir_detail_div").rup_dialog({
		autoOpen: false,
		width: 700,
		modal: true,
		position: { my: "center center" },
		type: $.rup.dialog.DIV,
		close: function(){
			limpiarFormulario();
		}
	});
	
	var listOpciones = new Array();
	listOpciones[0] = {i18nCaption: $.rup.i18n.app.comboRelOriDir.blank, value:""};
	listOpciones[1] = {i18nCaption: $.rup.i18n.app.comboRelOriDir.si, value:1};
	listOpciones[2] = {i18nCaption: $.rup.i18n.app.comboRelOriDir.no, value:2};

	//Transformo en JSON la lista
	$.toJSON(listOpciones);	
	$("#informeTecnicoSeleccionado").rup_combo({
		source: listOpciones,	
		width : 200
	});	
	
	//Cerrar modal mantenimiento
	$("#relOriDir_detail_button_cancel").click(function(){
		$("#relOriDir_detail_div").rup_dialog("close");
	});
	
	$("#relOriDir_detail_button_save").click(function(){
		
		var tablaRelOriDir = $("#relOriDireccion").DataTable();
		
		$("#relOriDir_detail_form").rup_form({
			feedback: $("#relOriDir_detail_feedback"),
			url: CTX_PATH + "relOriDir/updateRelOriDir",
			type: "PUT",
			validate: {
				rules: {
					"informeTecnico"  : { required : true }
				}
			},
			success: function(){
				$("#relOriDir_detail_div").rup_dialog("close");
				$("#relOriDireccionFeedback").rup_feedback("set", $.rup.i18n.app.relOriDir.guardarOk, "ok");
				tablaRelOriDir.ajax.reload();
				filaSeleccionadaRelOriDir = "";
			},
			error: function(){
				$("#relOriDir_detail_feedback").rup_feedback("set", $.rup.i18n.app.relOriDir.guardarError, "error");
				filaSeleccionadaRelOriDir = "";
			}
		});
		$("#relOriDir_detail_form").submit();
	});
});

//Recuperar la pregunta a editar
function recuperarRegistro(){
	$.ajax({
		type: "GET",
		url: CTX_PATH + "relOriDir/" + filaSeleccionadaRelOriDir.idRelOriDir,
		dataType: "json",
		success: function(data){
			$("#relOriDir_detail_div").rup_dialog("setOption", "title", $.rup.i18n.app.relOriDir.editar);
			$("#relOriDir_detail_div").rup_dialog("open");
			$("#idRelOriDirSeleccionado").val(data.idRelOriDir);
			$("#informeTecnicoSeleccionado").rup_combo("setRupValue", data.informeTecnico);
			desbloquearInterfaz();		
		},
		error: function(){
			desbloquearInterfaz();
			$("#relOriDireccionFeedback").rup_feedback("set", $.rup.i18n.app.preguntasProtocolo.recuperarPreguntaError, "error");
		}
	});
};

function limpiarFormulario() {
	$("div.error").each(function(){
		$(this).remove();
	});

	$("i.error").each(function(){
		$(this).remove();
	});
	
	$("input.error").each(function(){
		$("#"+this.id).removeClass("error");
	});

	$("#informeTecnicoSeleccionado").rup_combo("clear");
}


